> ## Documentation Index
> Fetch the complete documentation index at: https://docs.agents.labs.bandwidth.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List agent versions

> Retrieve an agent's version history.

Use the integer agent ID to retrieve saved versions. Inspect version status before comparing a draft with published behavior. See [test and publish](/voice-agent/publish).


## OpenAPI

````yaml GET /api/v1/workflow/{workflow_id}/versions
openapi: 3.1.0
info:
  title: Bandwidth Agent Builder API
  version: v1
  description: >-
    Manage agents, place calls, and retrieve conversation results in your
    workspace.
servers:
  - url: https://agents.labs.bandwidth.com
    description: Workspace API
security: []
paths:
  /api/v1/workflow/{workflow_id}/versions:
    get:
      tags:
        - agents
      summary: List agent versions
      description: Retrieve an agent's version history.
      operationId: get_workflow_versions_api_v1_workflow__workflow_id__versions_get
      parameters:
        - name: workflow_id
          in: path
          required: true
          schema:
            type: integer
            title: Workflow Id
        - name: limit
          in: query
          required: false
          schema:
            anyOf:
              - type: integer
                maximum: 100
                minimum: 1
              - type: 'null'
            title: Limit
        - name: offset
          in: query
          required: false
          schema:
            type: integer
            minimum: 0
            default: 0
            title: Offset
        - name: X-VOAI-ORGANIZATION-ID
          in: header
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            title: X-Voai-Organization-Id
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/WorkflowVersionResponse'
                title: >-
                  Response Get Workflow Versions Api V1 Workflow  Workflow Id 
                  Versions Get
        '404':
          description: Not found
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - LabsAuth: []
        - LabsApiKey: []
components:
  schemas:
    WorkflowVersionResponse:
      properties:
        id:
          type: integer
          title: Id
        version_number:
          type: integer
          title: Version Number
        status:
          type: string
          title: Status
        created_at:
          type: string
          format: date-time
          title: Created At
        published_at:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Published At
        workflow_json:
          additionalProperties: true
          type: object
          title: Workflow Json
        workflow_configurations:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Workflow Configurations
        template_context_variables:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Template Context Variables
      type: object
      required:
        - id
        - version_number
        - status
        - created_at
        - workflow_json
      title: WorkflowVersionResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    LabsAuth:
      type: http
      scheme: bearer
    LabsApiKey:
      type: apiKey
      in: header
      name: X-BW-LABS-AGENTS-API-KEY

````